/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;
import java.util.*;

/**
* Etude du dterminisme d'un automate.
*/
public class algo_DET {
    private automate auto0;
    private boolean isDET;
    public algo_DET(automate a) {

	auto0 = new automate(a);
	isDET = !auto0.getT_saisie().left_equals();
    }
    public automate getAuto0() {return auto0;}
    public boolean getIsDET() {return isDET;}
    /**
     *retourne un vecteur contenant toute les combinaisons possibles en fonction de l'arite.
     *ex: si arite=2 et a=({q1},{q2,q3},{q5})
     *alors Vector={({q1},{q1}),({q1},{q2,q3}),({q1},{q5}),({q2,q3},{q1}),({q2,q3},{q2,q3}),...}
     *@param ar arite
     *@param a ensemble de la forme ({q1},{q2,q3},{q5})   ( = Qd)
     */
    public Vector n_uplet(int ar,ensembleEtats a) {
	int arite = ar;
	int nb_combinaison=(int)java.lang.Math.pow((double)a.size(),(double)arite);
	Vector retour = new  Vector();

	for(int d=0;d<nb_combinaison;d++) {
	    retour.addElement(new String("("));
	}
	for(int i=0;i<arite;i++) {
	    int n=(int)java.lang.Math.pow((double)a.size(),(double)i);
	    int nn=(int)java.lang.Math.pow((double)a.size(),(double)(arite-1-i));
	    for(int j=0;j<n;j++) {
		for(int k=0;k<a.size();k++) {
		    for(int l=0;l<nn;l++) {
			int index=l+k*nn+j*((int)java.lang.Math.pow((double)a.size(),(double)(arite-i)));
			String aux = new String((String)retour.get(index));
			aux += a.getLibelle(k);
			if(i != arite-1) aux += ",";
			else aux += ")";
			retour.set(index,aux);
		    }
		}
	    }
	}
	return retour;
    }
    /**
     *retourne un vecteur contenant toute les combinaisons possibles.
     *ex: si s=({q1,q2},{q3},{q4,q5,q6})
     *alors Vector={(q1,q3,q4),(q1,q3,q5),(q1,q3,q6),(q2,q3,q4),...}
     *@param s de la forme ({q1,q2},{q3},{q4,q5,q6})
     */
    public Vector n_uplet2(String s) { 
	Vector retour = new Vector();
	if(s.indexOf('(') == -1 || s.indexOf(')') == -1 || s.indexOf('{') == -1 || s.indexOf('}') == -1) return retour;
	else {
	    try {
		//calcul de l'arite
		int arite = 0;
		int acco = 0;
		int accf = 0;
		int i = 0;
		while(i<s.length()) {
		    if(s.charAt(i) == '{') acco++;
		    if(s.charAt(i) == '}') accf++;
		    i++;
		}
		if(acco == accf) arite=acco;
		
		//on regroupe les etats dans un tableau
		//avec l'exemple de s, on obtient:
		//tabetat[0] contient q1 ,q2
		//tabetat[1] contient q3
		//tabetat[2] contient q4 ,q5 ,q6
		ensembleEtats[] tabetat  = new ensembleEtats[arite];
		String aux = new String(s.substring(s.indexOf('(')+1,s.lastIndexOf(')')));
		for(int j=0;j<arite;j++) {
		    tabetat[j] = new ensembleEtats();
		    String auxx = new String(aux.substring(aux.indexOf('{')+1,aux.indexOf('}')));
		    if(auxx.indexOf(';') == -1) tabetat[j].addEtat(auxx);
		    else {
			while(auxx.indexOf(';') != -1) {
			    tabetat[j].addEtat(auxx.substring(0,auxx.indexOf(';')));
			    auxx = auxx.substring(auxx.indexOf(';')+1,auxx.length());
			}
			tabetat[j].addEtat(auxx);
		    }
		    aux = aux.substring(aux.indexOf('}')+1,aux.length());
		}

		//remplissage du vecteur retour:
		for(int k=0;k<arite;k++) {
		    int nb = retour.size();
		    if(tabetat[k].size() > 1) {
			for(int l=1;l<tabetat[k].size();l++) {
			    for(int ll=0;ll<nb;ll++) {
				retour.add((String)retour.get(ll));
			    }
			}
		    }
		    int kk=0;
		    int nbb=0;
		    while(kk<tabetat[k].size()) {
			if(nb == 0) {
			    if(k == arite-1) retour.addElement(tabetat[k].getLibelle(kk));
			    else retour.addElement(tabetat[k].getLibelle(kk)+",");
			}
			else {
			    for(int n=0;n<nb;n++) {
				String saux = new String((String)retour.get(n+nbb));
				if(k == arite-1) saux += tabetat[k].getLibelle(kk);
				else saux += tabetat[k].getLibelle(kk)+",";
				retour.set(n+nbb,saux);
			    }
			}
			kk++;
			nbb += nb;
		    }
		}
		for(int l=0;l<retour.size();l++) {//parenthese
		    String auxxx= new String("("+(String)retour.get(l)+")");
		    retour.set(l,auxxx);
		}
	    }
	    catch (Exception e) {System.out.println("error n-uplet2: "+e.getMessage());
	    }
	}
	return retour;
    }
    /**
     *recherche si un ensemble d'etat est deja dans Qd (par ex: {Q1,Q2,Q3}={Q2,Q1,Q3}={Q3,Q1,Q2}=...)
     *@param s ensemble de la forme {Q1,Q2,Q3}
     *@param a ensemble d'etat Qd
     */
    public int containsAcc(String s,ensembleEtats a) {
	int retour = -1;
	int i=0;
	while(i<a.size()) {
	    if(s.equals(a.getLibelle(i))) {
		retour=i;
		i=a.size();
	    }
	    else {
		if(a.getLibelle(i).length() == s.length()) {
		    if(s.indexOf(';') != -1) {
			int nbv1=0;
			int nbv2=0;
			for(int j=0;j<s.length();j++) {
			    if(s.charAt(j) == ';') nbv1++;
			    if(a.getLibelle(i).charAt(j) == ';') nbv2++;
			}
			if(nbv1 == nbv2) {
			    String aaux = new String(a.getLibelle(i).substring(0,a.getLibelle(i).length()));
			    String saux = new String(s.substring(1,s.length()-1));
			    int ok=0;
			    while(saux.indexOf(';') != -1) {
				String ssaux = new String(saux.substring(0,saux.indexOf(';')));
				if(aaux.indexOf(ssaux+";") != -1) {
				    aaux = aaux.substring(0,aaux.indexOf(ssaux+";"))+aaux.substring(aaux.indexOf(ssaux+";")+ssaux.length()+1,aaux.length());
				}
				else {
				    if(aaux.indexOf(";"+ssaux+"}") != -1) {
					aaux = aaux.substring(0,aaux.indexOf(";"+ssaux+"}"))+"}";
				    }
				}
				saux = saux.substring(saux.indexOf(';')+1,saux.length());
			    }
			    if(aaux.indexOf(saux) != -1) {
				aaux = aaux.substring(0,aaux.indexOf(saux))+aaux.substring(aaux.indexOf(saux)+saux.length(),aaux.length());
			    }
			    if(aaux.equals("{}")) {
				retour=i;
				i=a.size();
			    }
			}
		    }
		}
	    }
	    i++;
	}
	return retour;
    }
    /**
     *verifie qu'il y a des symboles d'arite 0 dans alpha
     */
    public boolean symbole_arite0(alphabet alpha)
    {
	boolean ok = false;
	for (int i=0;i<alpha.size();i++)
	    {
		if (alpha.getArite(i)==0) { ok = true; }
	    }
	return ok;
    }
    /**
     *algo de determinisation
     */
    public automate DET() 
    {

	automate retour;
	
	alphabet Fd = auto0.getA_saisie().copy();
	
	Fd = Fd.sort_arite();
	
	ensembleEtats Qd = new ensembleEtats();
	ensembleTransitions Dd = new ensembleTransitions();

	alphabet Fdaux = Fd.copy();
	int arite=0; 
	//on initialise Qd avec les symboles d'arite 0:	
	int as = 0;
	while 	(!Fdaux.print().equals("ALPHABET = {  }\n") && symbole_arite0(Fdaux))  // LIGNE RAJOUTEE car sinon BUG
	    {
		as++;
	
		if (Fdaux.getArite(0) == arite)  
		    {
			
		
			String netat = new String("{");
			for(int i=0;i<auto0.getT_saisie().size();i++) 
			    {
			
				if(auto0.getCondition(i).getFonction().equals(Fdaux.getSymbole(0).getSymbole())) 
				    {
				
					if(!netat.equals("{")) netat += ";";
					netat += auto0.getEtatObtenu(i).getLibelle();
				
				    }
			    }
			netat += "}";
		
			if(!netat.equals("{}")) 
			    {
			
				Dd.addTransition(Fdaux.getSymbole(0).getSymbole(),new etat(netat));
				int verif = containsAcc(netat,Qd);
				if(verif != -1) netat=Qd.getLibelle(verif);
				Qd.addEtat(netat);
			
			    }
		
			Fdaux.removeElementAt(0);
		
			
		    }
	    }    

	boolean ajout = true;
	while(ajout) {
	    ajout=false;
	    int n=0;
	    while(n<Fdaux.size()) {
		arite=Fdaux.getArite(n);
		Vector nuplet = n_uplet(arite,Qd);
		int i=0;

		while(i<nuplet.size()) {
		    Vector nuplet2 = n_uplet2((String)nuplet.get(i));
		    int j=0;
		    String newetat = new String("{");
		    while(j<nuplet2.size()) {
			String PG = new String(Fdaux.getSymbole(n).getSymbole()+(String)nuplet2.get(j));
			int k=0;
			while(k<auto0.getT_saisie().size()) {
			    if(auto0.getCondition(k).getFonction().equals(PG)) {
				if(!newetat.equals("{")) newetat += ";";
				String etat = new String(auto0.getEtatObtenu(k).getLibelle());
				if(newetat.indexOf(etat+";") == -1 && newetat.indexOf(etat+"}") == -1) newetat += etat;
				else newetat = newetat.substring(0,newetat.length()-1);
			    }
			    k++;
			}
			j++;
		    }

		    newetat += "}";
		    if(!newetat.equals("{}")) {
			int verif = containsAcc(newetat,Qd);
			if(verif != -1) newetat=Qd.getLibelle(verif);
			Dd.addTransition(new String(Fdaux.getSymbole(n).getSymbole()+(String)nuplet.get(i)),new etat(newetat)); 
			if(!Qd.contains(new etat(newetat))) {
			    Qd.addEtat(newetat);
			    ajout=true;
			    i=nuplet.size();
			    n=Fdaux.size();
			}
		    }
		    i++;
		}
		n++;
	    }
	}
	//etats finaux:

	for(int p=0;p<auto0.getE_saisie().size();p++) {
	    if(auto0.isFinal(p)) {
		String efinal = new String(auto0.getLibelle(p));
		for(int pp=0;pp<Qd.size();pp++) {
		 
		    if(Qd.getLibelle(pp).indexOf(efinal+";") != -1 || Qd.getLibelle(pp).indexOf(efinal+"}") != -1) Qd.setFinal(pp,true);
		}
	    }
	}

	retour = new automate(Fd,Qd,Dd,auto0.getARR_saisie());
	return retour;
    }
    /**
     *retourne l'automate determinise
     */
    public automate auto_DET() {

	automate retour;

	if(!isDET) retour = this.DET();

	else retour = auto0;
	return retour;
    }
}
