/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

import java.util.*;

/**   
* C'est un ensemble de symboles.   
*/   
public class alphabet extends Vector{   
    /**  
     *Cre un alphabet vide.   
     */   
    public alphabet(){   
	super();   
    }   
    // cree l'alphabet des symboles d'arite la valeur passe en parametre pour l'alphabet alp1
    public alphabet alphabetRR(alphabet alp1, int arite)
    {

	alphabet alp2=new alphabet();
	alphabet alp3=new alphabet();
	for (int i=0;i<alp1.size();i++) alp2.addSymbole((symbole)alp1.elementAt(i));
	for (int i=0;i<arite-1;i++) 
	    {
	    for (int j=0;j<alp1.size();j++)
		for (int k=0;k<alp2.size();k++){
		    String sym = ((symbole)alp2.elementAt(k)).getSymbole()+"|"+((symbole)alp1.elementAt(j)).getSymbole();
		    int n1 = ((symbole)alp2.elementAt(k)).getArite(); 
   		    int n2 = ((symbole)alp1.elementAt(j)).getArite();
		    int n3;
		    if ( n1<n2 ) 
			 n3 = n2;
		    else
			n3 = n1;
		    symbole sim = new symbole(sym+"/"+n3);
		    alp3.addElement(sim);
		}
	    alp2=alp3.copy();
	    alp3 = new alphabet();
	}  
	return alp2;
     }
    /**   
    * Ajoute un symbole dans l'alphabet.   
    * @param s Le symbole ajout.   
    */   
    public void addSymbole(symbole s){  
	
	addElement(s);   
    }   
    /**   
    * Ajoute un symbole dans l'alphabet.   
    * @param symbole Le symbole ajout sous forme de chaine (nom/arit).   
    */   
    public void addSymbole(String s){   
	addSymbole(new symbole(s));   
    }   
    /**   
    * Retourne le i-me symbole.   
    * @param i Index du symbole.   
    */   
    public symbole getSymbole(int i){  

 
	return (symbole)elementAt(i);   
    }   
    /**   
    * Retourne l'objet symbole correspondant  un libell.   
    * @param symbole Libell du symbole.   
    */   
    public symbole getSymbole(String s){ 
	if ( s.indexOf("/")!=-1)
	    s = s.substring(0,s.indexOf("/"));

	print();
	return getSymbole(getSymboleIndex(s));   
    }   
    /**
     *retourne l'arite du i-me symbole.
     *@param i index du symbole
     */
    public int getArite(int i) {
      
	return getSymbole(i).getArite();
    }
    /**   
    * Retourne l'index du symbole correspondant  un libell.   
    * @param symbole Libell du symbole (nom/arit).   
    */   
    public int getSymboleIndex(String s){   
	int retour=-1;   
	for(int i=0;i<size();i++){   
	    if(getSymbole(i).isEqual(s)){ 
	
		retour = i;   
		break;   
	    }   
	}   
	return retour;   
    }
    /**
    * Indique si 2 alphabets sont gaux.
    */
    public boolean equals(alphabet a){
	boolean retour = true;
	if(a.size()!=size()){
	    retour = false;
	}else{
	    boolean use_j[] = new boolean[size()];
	    for(int j=0;j<size();j++)
		use_j[j]=false;
	    for(int i=0;i<size();i++){
		boolean ok_i = false;
		for(int j=0;j<size();j++){
		    if(!use_j[j]){
			if(getSymbole(i).equals(a.getSymbole(j))){
			    ok_i=true;
			    use_j[j] = true;
			    break;
			}
		    }
		}
		if(!ok_i){
		    retour = false;
		    break;
		}
	    }
	}
	return retour;
    }
    /**
    * Tri les symbole dans l'ordre alphabetique du liblle.
    */
    public void sort(){
	alphabet trie = new alphabet();	
	while(size()>0){
	    int max = 0;
	    for(int i=0;i<size();i++){
		if(getSymbole(i).getLibelle().compareTo(getSymbole(max).getLibelle())>0)
		    max = i;
	    }
	    trie.insertElementAt(getSymbole(max),0);
	    removeElementAt(max);
	}
	for(int i=0;i<trie.size();i++)
	    addSymbole(trie.getSymbole(i));
    }
    /**
     *tri les symboles dans l'ordre croissant de leur arite
     */
    public alphabet sort_arite() {
	alphabet trie = new alphabet();	
	int arite=0;
	while(trie.size() < this.size()) {
	    for(int i=0;i<this.size();i++) {
		if(this.getArite(i) == arite) trie.addSymbole(this.getSymbole(i));
	    }
	    arite++;
	}
	return trie;
    }
    /**
    * Retourne une chaine reprsentant l'alphabet:
    */
    public String print(){
	String retour = new String("ALPHABET = { ");
	for(int i=0;i<size();i++){
	    if(i==size()-1)
		retour = retour + getSymbole(i).getSymbole() + "/" + getSymbole(i).getArite();
	    else
		retour = retour + getSymbole(i).getSymbole() + "/" + getSymbole(i).getArite()+" , ";
	}
	retour = retour + " }\n";
	return retour;
    }
    /**
    * Retourne l'arit du symbole si il existe et -1 sinon
    */
    public int app(String sym)
    {
	int arit=-1;
	for ( int i=0;i<this.size();i++)
	    {
	
		if ( this.getSymbole(i).getSymbole().equals(sym) )
		    { 
			arit = this.getSymbole(i).getArite();
		    }	    
	    }

	
	return arit;
    }
    /**
    * Retourne une copie de l'alphabet.
    */
	public alphabet copy(){
	alphabet retour = new alphabet();
	for(int i=0;i<size();i++)
	    retour.addSymbole(getSymbole(i).copy());
	return retour;
    }
}
