/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

import java.io.*;
import java.util.*;

/** 
 *Represente un automate. 
 */ 
public class automate { 
  
    /** 
     *Alphabet saisie 
     */ 
    private alphabet a_saisie;
    /** 
     *Alphabet symboles simples pour cas RR
     */ 
    private alphabet arr_saisie; 
    /** 
     *Etats saisies 
     */ 
    private ensembleEtats e_saisie; 
    /** 
     *Regles de transitions saisies 
     */ 
    private ensembleTransitions t_saisie; 
    /** 
     *Message d'erreur lie a la creation d'un automate 
     */ 
    private String exception; 
    /** 
     *Indique si l'automate saisie est valider 
     */ 
    
    private boolean automate_ok; 
    /** 
     *Cree un nouvel automate 
     */ 
    public int isRR = 1;
    public automate() { 
	a_saisie = new alphabet();
	arr_saisie = new alphabet(); 
	e_saisie = new ensembleEtats(); 
	t_saisie = new ensembleTransitions(); 
	exception = null; 
	automate_ok=false; 

    } 
    /** 
     *Cree un nouvel automate 
     */ 
    public automate(automate a) { 
	a_saisie = a.a_saisie; 
	arr_saisie = a.arr_saisie; 
	e_saisie = a.e_saisie; 
	t_saisie = a.t_saisie; 
	exception = null; 
	automate_ok=false; 

    }
    /** 
     *Cree un nouvel automate 
     */ 
    public automate(alphabet a, ensembleEtats e, ensembleTransitions t,alphabet arr) { 
	a_saisie = a; 
	arr_saisie = arr;
	e_saisie = e; 
	t_saisie = t; 
	exception = null; 
	automate_ok=false; 
    }
    /** 
     *Cree un nouvel automate a partir d'un fichier 
     */ 
    public automate(File fichier) { 

	a_saisie = new alphabet(); 
	arr_saisie = new alphabet(); 
	e_saisie = new ensembleEtats(); 
	t_saisie = new ensembleTransitions(); 
	exception = null; 
	automate_ok=false; 
	try { 
	    BufferedReader in = new BufferedReader(new FileReader(fichier)); 
	    String line; 
	  	    if ((line=in.readLine()) != null) { 
		if(line.trim().equals("Length of tree-tuples:"))
		    {
			line=in.readLine();
			while (line.trim().equals("")) { line=in.readLine(); }
			isRR = (new Integer(line)).intValue();
			line=in.readLine();
			while (line.trim().equals("")) { line=in.readLine();  }
	
			if(line.trim().equals("Symbols:")) { 
			    line=in.readLine(); 
			    while(!line.trim().equals("States:")) { 
				
			
				symbole s = new symbole(line); 
				addSymbole(s); 
				line=in.readLine();
				
				while (line.trim().equals(""))  line=in.readLine(); 
			    } 	
			 			    line=in.readLine();
			    while (line.trim().equals("")) line=in.readLine(); 
			    while(!line.trim().equals("Transitions:")) { 
				if(line.endsWith("(final)")) addEtat(line.substring(0,(line.indexOf("(final)")-1)),true); 
				else addEtat(line,false); 
				line=in.readLine(); 
				while (line.trim().equals("")) line=in.readLine();
			    } 
			    line=in.readLine(); 
					    
			    while(!line.trim().equals("SymbolRRs:") && !line.trim().equals("."))
				{ 
				    String gauche = new String(line.substring(0,line.indexOf("->"))); 
				    String droite = new String(line.substring(line.indexOf("->")+2,line.length())); 
				    addTransition(gauche,new etat(droite,isFinal(droite))); 
				    line=in.readLine(); 
				    while (line.trim().equals("")) line=in.readLine();
				} 
			}
					if ( !line.trim().equals(".") )
			    {
				line=in.readLine(); 
				while(!line.trim().equals("."))
				    { 
									symbole s = new symbole(line.trim()); 
					arr_saisie.addSymbole(s); 
					line=in.readLine(); 
					while (line.trim().equals("")) line=in.readLine();
				    } 
			    }
				    } 
		
	    
		else setException("Error: incompatible file"); 
	    } 
	    else setException("Error: incompatible file"); 
	} 
	catch(Exception e) { 
	    setException(" Error: " + e.getMessage()); 
	} 
    }
    /**
     * Retourne une copie de l'automate.
     */
    public automate copy(){
	alphabet a_temp = getA_saisie().copy();
	alphabet arr_temp = getARR_saisie().copy();
	ensembleEtats e_temp =getE_saisie().copy();
	ensembleTransitions t_temp =getT_saisie().copy();
	automate retour = new automate(a_temp,e_temp,t_temp,arr_temp);
	retour.isRR=isRR;
	return retour;
    }              
    /** 
     *Teste si l'automate est vide ou non 
     */ 
    public boolean automate_incomplet() { 
	return a_saisie.isEmpty() || e_saisie.isEmpty() || t_saisie.isEmpty(); 
    }
    /**
    * Retourne l'automate sous forme de chaine.
    */
    public String print(){
	String retour = new String();
	retour += getA_saisie().print()+"\n";
	retour += getE_saisie().print()+"\n";
	retour += getT_saisie().print();
	return retour;
    }    
   
    /*--------------------------Alphabet a_saisie----------------------------*/
    /** 
    * Retourne l'ensemble de symbole saisie 
    */ 
    public alphabet getA_saisie() { 
	return a_saisie; 
    }
    /** 
    * Retourne l'ensemble des symboles saisie pour RR
    */  
    public alphabet getARR_saisie() { 
	return arr_saisie; 
    } 
    /** 
     *Ajoute un symbole dans l'automate 
     *@param s Symbole a ajouter 
     */  
    public void addSymbole(symbole s) { 
	a_saisie.addSymbole(s); 
    } 
    /** 
     *Retourne un symbole de l'automate 
     *@param i Index du symbol a retourner 
     */  
    public String getSymbole(int i) { 
	return a_saisie.getSymbole(i).getSymbole(); 
    } 
    /** 
     *Retourne l'arite d'un symbole de l'automate 
     *@param i Index du symbole 
     */ 
    public int getArite(int i) { 
	return a_saisie.getSymbole(i).getArite(); 
    } 
    /*--------------------------Etats e_saisie-------------------------------*/
    /** 
    * Retourne l'ensemble des etats saisies 
    */ 
    public ensembleEtats getE_saisie() { 
	return e_saisie; 
    }
    /** 
     *Ajoute un etat dans l'automate 
     *@param etat Etat a ajouter 
     *@param finall Indique si l'etat est final ou non 
     */ 
    public void addEtat(String etat,boolean finall) { 
	e_saisie.addEtat(etat,finall); 
    } 
    /** 
     *Ajoute un etat dans l'automate 
     *@param e Etat a ajouter      
     */ 
    public void addEtat(etat e) { 
	    e_saisie.addEtat(e); 
    } 
    /** 
    * Retourne le i-me tat. 
    */ 
    public etat getEtat(int i){ 
	return e_saisie.getEtat(i); 
    } 
    /**Retourne le libelle d'un etat de l'automate 
     *@param i Index de l'etat  
     */ 
    public String getLibelle(int i) { 
	return e_saisie.getEtat(i).getLibelle(); 
    }     
    /** 
     *Retourne vrai si l'etat est final,sinon faux 
     *@param i Index de l'etat 
     */ 
    public boolean isFinal(String etat) { 
	return e_saisie.isFinal(etat); 
    } 
    /** 
     *Retourne vrai si l'etat est final,sinon faux 
     *@param i Index de l'etat 
     */ 
    public boolean isFinal(int i) { 
	return e_saisie.isFinal(i); 
    } 
    /*-----------------------transitions t_saisie-----------------------------*/
    /** 
    * Retourne l'ensemble des regles saisies 
    */ 
    public ensembleTransitions getT_saisie() { 
	return t_saisie; 
    }
    /** 
    * Ajoute une rgle de transition dans l'ensemble. 
    * @param gauche Partie gauche de la rgle (une expression sous forme de chaine). 
    * @param droite Partie droite de la rgle (un tat). 
    */ 
    public void addTransition(String gauche, etat droite){ 
	t_saisie.addTransition(gauche,droite); 
    } 
    /** 
    * Retourne la i-me transition de l'ensemble 
    * @param i Index de la transition. 
    */ 
    public transition getTransition(int i){ 
	return t_saisie.getTransition(i); 
    } 
    /** 
    * Retourne la partie gauche de la i-me rgle.     
    * @param i l'index de la rgle. 
    */ 
    public expression getCondition(int i){ 
	return t_saisie.getCondition(i); 
    } 
    /** 
    * Retourne la partir droite de la i-me rgle. 
    * @param i l'index de la rgle. 
    */ 
    public etat getEtatObtenu(int i){ 
	return t_saisie.getEtatObtenu(i); 
    } 
    /** 
    * Indique si la i-me rgle de transition est satisfaite par un arbre. 
    * @param i l'index de la rgle. 
    * @param a L'arbre  tudier. 
    */ 
    public boolean obtenue(int i, arbre a){ 
	return t_saisie.obtenue(i,a); 
    } 
    /*----------------------- exception -----------------------------*/ 
    /** 
     * attribut un message d'erreur 
     *@param s Message d'erreur 
     */ 
    public void setException(String s) { 
	exception = new String(s); 
    } 
    /** 
     * Retourne l'exception 
     */ 
    public String getException() { 
	return exception; 
    } 
    /*----------------------- automate_ok -----------------------------*/ 
    public void setAutomate_ok(boolean b) { 
	automate_ok=b; 
    } 
    public boolean getAutomate_ok() { 
	return automate_ok; 
    } 
    /*------------------------------------------------------------------*/
    /**
    * Renommage des tats lors de dterminisation.
    */
    public String rename(){
	boolean modif = false;
	String[] old_lib = new String[getE_saisie().size()];
	String[] new_lib = new String[getE_saisie().size()];
	//Parcourt de la liste d'tat. recherche de { ou de } et modif si necessaire.
	for(int i=0;i<getE_saisie().size();i++){
	    old_lib[i] = new String(getLibelle(i));
	    if(getE_saisie().getEtat(i).rename(i)){
		new_lib[i] = new String(getLibelle(i));
		modif = true;
	    }else{
		new_lib[i]=old_lib[i];
	    }
	}
	String retour = new String("");
	if(modif){
	    //Parcourt de la liste de rgles et modifs.
	    for(int j=0;j<getT_saisie().size();j++){
		//Modif de l'tat obtenu.
		for(int i=0;i<old_lib.length;i++){
		    if(getEtatObtenu(j).rename(old_lib, new_lib)){
			break;
		    }
		}
		//Modif de la condition.
		for(int i=0;i<old_lib.length;i++){
		    getCondition(j).getArbre().rename(old_lib, new_lib);
		    getCondition(j).setFonction();
		}
	    }
	    retour = new String(old_lib[0] + " -> " + new_lib[0]);
	    for(int i=1;i<old_lib.length;i++){
		retour += "\n" + old_lib[i] + " -> " + new_lib[i];
	    }
	}		
	return retour;
    }
}
