/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

/**   
* un tat est dfini par un libelle et un boolen indiquant s'il est final.   
*/  
public class etat{   
    /**   
    * Libell de l'tat   
    */   
    private String etat;   
    /**   
    * Indique si l'tat est final   
    */   
    private boolean eFinal;   
    /**   
    * Construit un nouvel tat non final.   
    * @param etat Libell de l'tat.   
    */   
    public etat(String s){   
	etat = s;   
	eFinal = false;   
    }   
    /**   
    * Construit un nouvel tat.   
    * @param etat Libell de l'tat.   
    * @param eFinal Indique si l'tat est final (true) ou non (false)   
    */   
    public etat(String s, boolean b){   
	etat = s;   
	eFinal = b;   
    }   
    /**   
    * Change la condition "final" d'un tat.   
    * @param eFinal La nouvelle valeur de final.   
    */   
    public void setFinal(boolean b){   
	eFinal = b;   
    }   
    /**   
    * Indique si l'tat est final.   
    */   
    public boolean isFinal(){   
	return eFinal;   
    }   
    /** 
    * Indique si 2 tats sont gaux. 
    */ 
    public boolean equals(etat e){ 

	return ((isFinal()==e.isFinal()) && (getLibelle().equals(e.getLibelle()))); 
    } 
    /**   
    * Retourne le libell de l'tat.   
    */   
    public String getLibelle(){   
	return etat;   
    }
    /**
    * Retourne une copie de l'tat.
    */
    public etat copy(){
	return (new etat(getLibelle(),isFinal()));
    }
    /**
    * Renomme l'tat si prsence de { ou }
    */
    public boolean rename(int i){
	boolean retour = false;
	//le libelle contient
	if( (getLibelle().lastIndexOf('{')!=-1) || (getLibelle().lastIndexOf('}')!=-1) ){
	    etat = "Q" + i;
	    retour = true;
	}
	return retour;
    }
    /**
    * Renomme ...
    */
    public boolean rename(String[] old_lib, String[] new_lib){
	boolean retour = false;
	for(int i=0;i<old_lib.length;i++){
	    if(!new_lib[i].equals("") && getLibelle().equals(old_lib[i])){
		etat = new_lib[i];
		retour = true;
		break;
	    }
	}
	return retour;
    }
}
