/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

/** 
* Reprsente une expression fonctionnelle sous forme d'arbre. 
*/ 
public class expression{ 
    /** 
    * Reprsentation sous forme de chaine, par exemple: f(a,g(q)). 
    */ 
    private String fonction; 
    /** 
    * Reprsentation sous forme d'arbre. 
    */ 
    private arbre representation; 
    /** 
    * Cre une nouvelle expression fonctionnelle  partir d'une chaine. 
    */ 
    public expression(String e){ 
	fonction = e; 
	String temp = new String(); 
	int i=0; 
	int debut=0; 
	int ouvrante=0; 
	int fermante=0; 
	while(i<e.length()){ 
	    if(e.charAt(i)!='(' && e.charAt(i)!=',' && e.charAt(i)!=')'){ 
		temp+=e.charAt(i); 
		i++; 
		representation = new arbre(temp);} 
	    else{ 
		if(e.charAt(i)=='('){//on cherche la parenthse fermante. 
		    i++; 
		    debut=i;//dbut des paramtres de la fonction. 
		    ouvrante = 1; 
		    fermante = 0; 
		    while(i<e.length() && ouvrante!=fermante){ 
			if(e.charAt(i)==')') 
			    fermante++; 
			if(e.charAt(i)=='(') 
			    ouvrante++; 
			i++; 
		    }//while 
		    if(ouvrante==fermante){ 
			int fin=i-1; 
			if(debut!=fin){ 
			    String params = e.substring(debut,fin); 
			    //Dcoupe des paramtres: 
			    String param = new String(); 
			    int param_ouvrante=0;//nb de parenthses ouvrantes. 
			    int param_fermante=0;//nb de parenthses fermantes. 
			    int j=0; 
			    while(j<params.length()){ 
				if(params.charAt(j)==','){ 
				    if(param_ouvrante==0 || param_ouvrante==param_fermante){//fin du paramtre. 
					//ajout dans le sous arbre. 
					expression ei = new expression(param); 
					representation.addSousArbre(ei.representation); 
					param=new String(); 
				    }else{//toujours dans le param. 
					param=param+params.charAt(j);} 
				} 
				else{//toujours dans le param. 
					param=param+params.charAt(j);} 
				if(params.charAt(j)=='('){ 
				    param_ouvrante++;} 
				if(params.charAt(j)==')'){ 
				    param_fermante++;} 
				j++; 
			    } 
			    expression ei = new expression(param); 
			    representation.addSousArbre(ei.representation); 
			}//if 
		    }//if 
		}//if 
	    }//else 
	}//while 
    }//expression
    /**
    * Indique si l'expression contient l'argument indiqu.
    * @parm arg Argument recherch.
    */
    public boolean contains(String arg){
	return getArbre().contains(arg);
    }
    /** 
    * Indique si 2 expressions sont gales. 
    */ 
    public boolean equals(expression e){ 
	return getFonction().equals(e.getFonction()); 
    } 
    /** 
    * Retourne l'arbre reprsentant l'expression. 
    */ 
    public arbre getArbre(){ 
	return representation; 
    } 
    /** 
    * Retourne l'expression sous forme de chaine. 
    */ 
    public String getFonction(){ 
	return fonction; 
    } 
    /**
    * Representation chaine.
    */
    public void setFonction(){

	fonction = new String(representation.print());
    }
}//class expression 
