/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

/**
* Reduction d'un automate d'arbre.
*/
public class reduction{
    private automate depart;
    private automate reduit;
    private boolean est_reduit;
    /**
     * Construit un nouvel objet pour l'tude de la rduction d'un automate.
     */
    public reduction(automate a){
	depart = a.copy();	
	est_reduit = reduit();
    }
    /** 
     * Verifie si l'automate est reduit (ie: tous les tats sont atteignables). 
     */ 
    private boolean reduit(){
	
	//Indique les tats non atteints.
	boolean atteints[] = new boolean[depart.getT_saisie().size()];
	//Initialisation des tableaux 
	for(int i=0;i<depart.getT_saisie().size();i++) 
	    atteints[i]=false;
	

	ensembleEtats ens = new ensembleEtats();
	boolean etat_final = false;

	for (int i=0;i<depart.getT_saisie().size();i++)
	    {
	
		String symb = depart.getT_saisie().getTransition(i).getCondition().getFonction();
		
		if ( symb.indexOf("(")== -1 )
		    { 
		
			if (depart.getA_saisie().getSymbole(symb).getArite() == 0) 
			    {	
			
				ens.addEtat(depart.getT_saisie().getTransition(i).getEtatObtenu());
				atteints[i] = true;
			    }
		    }
	    }
   	

	boolean ok = true;	
    

	while (ok)
	    {
			
	
		ok = false;
		ensembleEtats ens2 = ens;
	
	
		for (int i=0;i<depart.getT_saisie().size();i++)
		    {
			
			arbre arbre1= depart.getT_saisie().getTransition(i).getCondition().getArbre();
			boolean pas_dedans = false;
		
			if (arbre1.getSousArbres().size() !=0 )
			    {
			
				sous_arbres sousarbre1 = arbre1.getSousArbres();
				for (int j =0;j<sousarbre1.size();j++)
				    {
				
					if ( !ens.contains2(sousarbre1.getValeur(j)) ) pas_dedans = true;
					
				    }
		
				if ( ! pas_dedans)
				    {
					if ( !ens.contains(depart.getT_saisie().getTransition(i).getEtatObtenu()))
					    
					    {
					
						ens.addEtat(depart.getT_saisie().getTransition(i).getEtatObtenu());
					
						ok = true;
					    }
					
					atteints[i] = true; 
				    }
				
			    }
		    }
	    }		
		
	
		boolean retour = true;
		//ensemble d'tats de l'automate rduit.
		ensembleEtats Qr = new ensembleEtats();
		//ensemble de transition de l'automate rduit.
		ensembleTransitions Dr = depart.getT_saisie().copy();
		ensembleTransitions Dr2 = new ensembleTransitions();
		//alphabet de l'automate rduit.
		alphabet Fr = depart.getA_saisie().copy();	
		//On vrifie si tous les tats sont atteints
		//et on construit l'automate rduit.
	
		for (int i=0;i<Dr.size();i++)
		    {
			if ( !atteints[i] )
			    {
				//Dr.removeElementAt(i);
				retour = false;
				//i--;
			    }
			else
			    {
			
				Qr.addEtat(Dr.getTransition(i).getEtatObtenu());
				Dr2.addTransition(Dr.getTransition(i));
			    }
		
		    }
		//Automate rduit.
		reduit = new automate(Fr,Qr,Dr2,depart.getARR_saisie());      
		reduit.isRR = depart.isRR;
	
		return retour; 
  }
    /**
     * Indique si l'automate est reduit.
     */
    public boolean isReduit(){
	return est_reduit;
    }
    /**
     * Retourne l'automate rduit.
     */
    public automate auto_reduit(){
	automate retour = depart;
	if(!isReduit())
	    retour = reduit;
	return retour;
    }
}
