/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

/**
* Etude d'un expression par un automate.
*/
public class run{ 
    /** 
    * Automate utils. 
    */ 
    private automate a; 
    /** 
    * Expression tudie. 
    */ 
    private expression e; 
    /** 
    * Etats successifs du run. 
    */ 
    private sous_arbres the_runs; 
    /** 
    * Rgles utilises. 
    */ 
    private ensembleTransitions transitions; 
    /** 
    * Rsultat de l'tude de l'expression par l'automate. 
    */ 
    private boolean resultat; 
    private boolean ok;
    private int l=0;//DEBUG 
    private int er=0;
     
    public run(automate a, expression e){ 
	ok = false;
        this.a=a; 
        this.e=e; 
        this.the_runs = new sous_arbres();         
        this.transitions = new ensembleTransitions(true); 
        arbre the_run = e.getArbre().copy(); 
        arbre temp = e.getArbre().copy();                 
        resultat = move(temp, null , temp,the_run, null , the_run);                 
	
    }         
    /** 
    * Retourne le rsultat de l'tude. 
    */ 
    public boolean getResultat(){ 
        return resultat; 
    }  
    // retourne un boolean qui indique si au moins une transition a pu etre aplliquee
    public boolean getOk(){ 
        return ok; 
    } 
    /** 
    * Retourne les tats du run. 
    */ 
    public sous_arbres getRuns(){ 
        return the_runs; 
    } 
    /** 
    * Retourne le i-me tat du run. 
    */ 
    public arbre getRun(int i){ 
        return the_runs.getArbre(i); 
    } 
    /** 
    * Retourne le run (dans son tat final). 
    */ 
    public arbre getTheRun(){ 
        return the_runs.getArbre(the_runs.size()-1); 
    } 
    /** 
    * Retourne les rgles utilises. 
    */ 
    public ensembleTransitions getTransitions(){ 
        return transitions; 
    } 
    /** 
    * Retourne la i-me rgle utilise. 
    */ 
    public transition getTransition(int i){ 
        return transitions.getTransition(i); 
    } 
    /** 
    * Retourne le nombre de transitions. 
    */ 
    public int getNombreTransitions(){ 
        return transitions.size(); 
    } 
    /** 
    * Retourne l'expression tudie. 
    */ 
    public expression getExpression(){ 
        return e; 
    } 
    /** 
    * Etude de l'expression. 
    */ 
    private boolean move(arbre temp_depart,arbre temp_parent,arbre temp_courant,arbre run_depart,arbre run_parent,arbre run_courant)
    {      
        boolean retour = false;  
	String s =         temp_depart.getValeur();
	etat nouv=new etat(s,true);
	etat nouv2=new etat(s,false);


	
	

	if (  1==1 ) // a.getE_saisie().contains(nouv) || a.getE_saisie().contains(nouv2) )
	
	    {
	
		if(temp_depart.getSousArbres().size()==0 && (a.getE_saisie().contains(nouv) || a.getE_saisie().contains(nouv2))
		   )
		    { 
					//l'arbre est rduit  une feuille: si l'tiquette de cette feuille 
			//est un tat final, l'expression est reconnue.  
			
		
			retour = a.getE_saisie().isFinal(temp_depart.getValeur()); 
			
		    }
		else
		    { 
					//parcourt des rgles de transition et comparaison des conditions avec temp_courant 
			boolean trouve = false; 
			int cok = -1; 
			for(int i=0;i<a.getT_saisie().size();i++)
			    { 
				if(a.obtenue(i,temp_courant))
				    { 
					trouve=true; 
					cok=i; 
					break; 
				    } 
			    } 
			if(trouve)
			    { 
				ok = true;
				if(temp_parent!=null)
				    { 
				//Modification de l'arbre de parent (on remplace les sous-arbre actuel par le rsultat de la transition). 
					arbre nouveau = new arbre(a.getEtatObtenu(cok).getLibelle()); 
					int ancien = temp_parent.getSousArbres().getArbreIndex(temp_courant); 
					temp_parent.getSousArbres().removeElementAt(ancien); 
					temp_parent.getSousArbres().insertElementAt(nouveau,ancien); 
				//run 
					run_parent.getSousArbre(ancien).setValeur(a.getEtatObtenu(cok).getLibelle()); 
					run_parent.getSousArbre(ancien).setMarque(true);                     
				//Ajout du run intermdiaire dans le vecteur.                     
					the_runs.addArbre(run_depart.copy()); 
					run_parent.getSousArbre(ancien).setMarque(false); 
				//run_parent.getSousArbre(ancien).setMarque(false); 
				//Ajout de la rgle utilise dans le vecteur de rgles. 
					transitions.addTransition(a.getTransition(cok)); 
				//On recommence avec l'arbre de dpart modifi. 
					er=1;
					retour = move(temp_depart,null,temp_depart,run_depart,null,run_depart);
				    } 
				else
				    {
				//temp_parent==null 
				//Modification de l'arbre de dpart. 
					arbre nouveau = new arbre(a.getEtatObtenu(cok).getLibelle());                     
					temp_depart = nouveau; 
				//run 
					run_depart.setValeur(a.getEtatObtenu(cok).getLibelle()); 
					run_depart.setMarque(true);                     
				//Ajout du run intermdiaire dans le vecteur. 
					the_runs.addArbre(run_depart.copy()); 
					run_depart.setMarque(false); 
				//Ajout de la rgle utilise dans le vecteur de rgles. 
					transitions.addTransition(a.getTransition(cok)); 
				//On recommence avec l'arbre modifi. 
					er =1;
					retour = move(temp_depart,null,temp_depart,run_depart,null,run_depart); 
				    }//else 
			    }
			else
			    { 
				    //pas de modification possible  ce niveau, on passe au suivant. 
				for(int i=0;i<temp_courant.getSousArbres().size();i++)
				    {    
					er =1;
					retour = retour || move(temp_depart,temp_courant,temp_courant.getSousArbre(i),run_depart,run_courant,run_courant.getSousArbre(i));                     
				    }//for 
			    }//else 
		    }//else 
		
	    }
	else 
	    {
		
		return false;
	    }
	if ( er ==0 )
	    {
		the_runs.addArbre(run_depart.copy());	
	    }
        return retour; 
    }//move 
    
}//class run 
