/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

import java.util.*;
import java.awt.*;

/** 
* Represente un ensemble d'arbre. 
*/ 
public class sous_arbres extends Vector{ 
    /** 
    * Cre un nouvel ensemble d'arbre vide. 
    */ 
    public sous_arbres(){ 
    	super(); 
    } 
    /** 
    * Ajout d'un arbre dans l'ensemble. 
    * @param a Arbre ajout. 
    */ 
    public void addArbre(arbre a){ 
	    addElement(a); 
    } 
    /** 
    * Ajout d'un arbre dans l'ensemble. 
    * @param valeur Libell de la racine de l'arbre ajout. 
    */ 
    public void addArbre(String valeur){ 
    	addArbre(new arbre(valeur)); 
    } 
    /** 
    * Retourne le i-me arbre de l'ensemble. 
    */ 
    public arbre getArbre(int i){ 
    	return (arbre)(elementAt(i)); 
    } 
    /** 
    * Retourne l'index d'un arbre. 
    * @param valeur Libell de la racine de l'arbre. 
    */ 
    public int getArbreIndex(String valeur){ 
    	int retour=-1; 
	    for(int i=0;i<size();i++){ 
	        if(getArbre(i).getValeur().equals(valeur)){ 
		        retour=i; 
		        break; 
	        } 
	    } 
	    return retour; 
    } 
    /** 
    * Retourne l'index d'un arbre. 
    * @param a Arbre recherch. 
    */ 
    public int getArbreIndex(arbre a){ 
    	int retour=-1; 
	    for(int i=0;i<size();i++){ 
	        if(getArbre(i).equals(a)){ 
		        retour=i; 
		        break; 
	        } 
	    } 
	    return retour; 
    } 
    /** 
    * Retourne la valeur de la racine du i-me arbre. 
    * @param i Index de l'arbre. 
    */ 
    public String getValeur(int i){ 
	    return getArbre(i).getValeur(); 
    }
    /**
    * Indique si l'un des arbres contient une racine indique.
    * @param lib Libell  rechercher.
    */
    public boolean contains(String lib){
	boolean retour=false;
	for(int i=0;i<size();i++){
	    if( (getValeur(i).equals(lib)) || (retour==true) ){
		retour = true;
		break;
	    }else{
		retour = retour || getArbre(i).contains(lib);
	    }
	}
	return retour;
    }
    /** 
    * Indique si 2 ensembles d'arbres sont gaux (permutations possibles). 
    * @param a l'ensemble avec lequel l'objet courant est compar. 
    */ 
    public boolean equals_permutation(sous_arbres sa){ 
	boolean retour = false;         
	if(size()==sa.size()){ 
	    retour = true; 
	    boolean utilise_j[] = new boolean[size()]; 
	    for(int j=0;j<size();j++) 
		utilise_j[j]=false;                 
	    boolean erreur=false;     
	    for(int i=0;i<size();i++){ 
		int j=0; 
		boolean trouve_i=false; 
		while(j<size() && !trouve_i){ 
		    if(!utilise_j[j]){ 
			if(getArbre(i).equals_permutation(sa.getArbre(j))){ 
			    utilise_j[j]=true; 
			    trouve_i=true; 
			    j=0; 
			}else{ 
			    j++; 
			} 
		    }else{ 
		       j++; 
		    }                     
		}//while j 
		if(!trouve_i){ 
		    retour = false; 
		    break;} 
	    }//for i 
	}//if size 
	 
	return retour; 
    } 
    /** 
    * Indique si 2 ensembles d'arbres sont gaux (pas de permutations). 
    * @param a l'ensemble avec lequel l'objet courant est compar. 
    */ 
    public boolean equals(sous_arbres sa){ 
	boolean retour = false;         
	if(size()==sa.size()){ 
	    retour = true; 
	    for(int i=0;i<size();i++){ 
		if(!getArbre(i).equals(sa.getArbre(i))){ 
		    retour = false; 
		    break; 
		}                 
	    }//for 
	}//if size 
	 
	return retour; 
    } 
    /**
    * Retourne une copie de l'ensemble.
    */
    public sous_arbres copy(){ 
	sous_arbres retour = new sous_arbres(); 
	for(int i=0;i<size();i++){ 
	    retour.addArbre(getArbre(i).copy()); 
	} 
	return retour; 
    } 
    /**
    * Renommage des variables lors de la dterminisation.
    */
    public void rename(String[] old_lib, String[] new_lib){
	for(int i=0;i<size();i++){
	    getArbre(i).rename(old_lib,new_lib);
	}
    }

    /*------------------Gestion de l'affichage------------------*/ 
    /** 
    * Gestion de l'affichage: Retourne la largeur de l'arbre en pixel. 
    * @param fonMetrics Pour connaitre la dimension des libells. 
    */ 
    public int largeur(FontMetrics fontMetrics){ 
    	int retour = 0; 
    	if(size()==0){ 
	        retour=0; 
	    }else{ 
	        for(int i=0;i<size();i++){ 
		        if(i!=size()-1) 
		            retour+=getArbre(i).largeur(fontMetrics)+ 10; 
		        else 
		            retour+=getArbre(i).largeur(fontMetrics); 
	        } 
	    } 
	    return retour; 
    } 
} 
