/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

/** 
* Reprsente une fonction de transition 
*/ 
public class transition{ 
    /** 
    * Partie gauche de la fonction: expression sous forme d'arbre. 
    */ 
    private expression condition; 
    /** 
    * Partie droite de la fonction: tat obtenu. 
    */ 
    private etat etat_obtenu; 
    /** 
    * Cre une nouvelle fonction. 
    * @param condition Partie gauche de la rgle. 
    * @param etat_obtenu Partie droite de la rgle. 
    */ 
    public transition(expression ex, etat e){ 
	condition = ex; 
	etat_obtenu = e; 
    } 
    /** 
    * Cre une nouvelle fonction. 
    * @param condition Partie gauche de la rgle sous forme de chaine. 
    * @param etat_obtenu Partie droite de la rgle. 
    */ 
    public transition(String s, etat e){ 
	condition = new expression(s); 
	etat_obtenu = e; 
    } 
    /** 
    * Retourne la partie gauche de la rgle.     
    */ 
    public expression getCondition(){ 
	return condition; 
    } 
    /** 
    * Retourne la partir droite de la rgle. 
    */ 
    public etat getEtatObtenu(){ 
	return etat_obtenu; 
    } 
    /** 
    * Indique si une rgle de transition est satisfaite par un arbre. 
    * @param a L'arbre  tudier. 
    */ 
    public boolean obtenue(arbre a){ 
	return condition.getArbre().equals(a); 
    } 
    /**
    * Indique si la partie gauche de la transition contient un argument indiqu.
    * @param arg Argument recherch.
    */
    public boolean contains(String arg){
	return getCondition().contains(arg);
    }
    /** 
    * Indique si les parties gauches de 2 rgles de transitions sont identiques. 
    */ 
    public boolean left_equals(transition t){ 
	return getCondition().equals(t.getCondition()); 
    } 
     /** 
    * Indique si les parties droites de 2 rgles de transitions sont identiques. 
    */ 
    public boolean right_equals(transition t){ 
	return getEtatObtenu().equals(t.getEtatObtenu()); 
    } 
     /** 
    * Indique si la partie droite de la rgle est l'tat indiqu. 
    * @param e Etat compar  la partie droite. 
    */ 
    public boolean right_equals(etat e){ 
	return getEtatObtenu().equals(e); 
    } 
    /** 
    * Indique si 2 rgles sont gales. 
    */ 
    public boolean equals(transition t){ 
	return (left_equals(t) && right_equals(t)); 
    } 
    /** 
    * Retourne la rgle sous forme de chaine. 
    */ 
    public String print(){ 
	return condition.getFonction()+"->"+etat_obtenu.getLibelle(); 
    }
    /**
    * Retourne une copie de la transition.
    */
    public transition copy(){
	return new transition(getCondition(),getEtatObtenu());
    }
}
