/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import data.*;
import java.util.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 

/** 
 *Fenetre de saisie principale 
 */ 
public class fenetre_saisie extends JFrame implements ActionListener { 
    /** 
     *Fenetre de saisie des symboles et des etats 
     */ 
    saisie_symbole_etat sse; 
    /** 
     *Fenetre de saisie des regles de transitions 
     */ 
    saisie_regle sr; 
    /** 
     *Fenetre de propriete de l'automate saisie 
     */ 
    propriete_automate prop; 
    /** 
     *Fenetre permettant de tester l'automate en cours 
     */ 
    fenetre_essai fe; 
    /**
    * Oprations sur des automates et des RR
    */
    operations op;
    /** 
     *conteneur des onglets 
     */ 
    JTabbedPane tab; 
    /** 
     *Automate saisie 
     */ 
    automate data;  
    alphabet alp = new alphabet();
    alphabet alphnew = new alphabet();
    /*
    * Rpertoire de l'utilisateur.
    */
    String user_dir;
    String selS,selE,selS2;
    int compteur;
    /** 
     *Construis la fenetre de saisie principale 
     */ 
    public fenetre_saisie(String user_dire) { 


	this.user_dir = user_dire;  //.substring(0,user_dire.lastIndexOf("/"));
	setTitle("TAJA - Tree-tuple Automata for JAva"); 
	getContentPane().setLayout(new BorderLayout()); 
	setSize(600,500); 
 	Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
	int w = getSize().width;
	int h = getSize().height;
	setBounds((dim.width-w)/2,(dim.height-w)/2,w,h);

	JMenuBar mb = new JMenuBar(); 
	JMenu m1 = new JMenu("File"); 
	JMenuItem m11 = new JMenuItem("New",new ImageIcon("images/new.gif")); 
	JMenuItem m12 = new JMenuItem("Open",new ImageIcon("images/open.gif")); 
	JMenuItem m13 = new JMenuItem("Save",new ImageIcon("images/save.gif")); 
	JMenuItem m14 = new JMenuItem("Quit",new ImageIcon("images/quit.gif")); 
	JMenu m2 = new JMenu("Help");
	JMenuItem m21 = new JMenuItem("About..."); 	
	JMenuItem m22 = new JMenuItem("Help"); 
	m11.addActionListener(this); 
	m12.addActionListener(this); 
	m13.addActionListener(this); 
	m14.addActionListener(this); 
	m21.addActionListener(this); 
	m21.setActionCommand("About");
	m22.addActionListener(this); 
	m22.setActionCommand("Help");
	
	m1.add(m11); 
	m1.add(m12); 
	m1.add(m13); 
	m1.add(new JSeparator()); 
	m1.add(m14);
 	m2.add(m21);
	m2.add(m22);

	mb.add(m1); 
	mb.add(m2);
	setJMenuBar(mb); 


	JToolBar jtb = new JToolBar(JToolBar.HORIZONTAL);
	jtb.setFloatable(false);
	JButton bnouveau  = new JButton(new ImageIcon("images/new.gif"));
	bnouveau.setToolTipText("New automaton");
	bnouveau.setActionCommand("New");
	bnouveau.addActionListener(this);
	jtb.add(bnouveau);
	jtb.addSeparator();
	JButton bouvrir  = new JButton(new ImageIcon("images/open.gif"));
	bouvrir.setToolTipText("Open an automaton");
	bouvrir.setActionCommand("Open");
	bouvrir.addActionListener(this);
	jtb.add(bouvrir);
	jtb.addSeparator();
	JButton benregistre  = new JButton(new ImageIcon("images/save.gif"));
	benregistre.setToolTipText("Save automaton");
	benregistre.setActionCommand("Save");
	benregistre.addActionListener(this);
	jtb.add(benregistre);
	jtb.addSeparator();
	JButton bquitter  = new JButton(new ImageIcon("images/quit.gif"));
	bquitter.setToolTipText("Close application");
	bquitter.setActionCommand("Quit");
	bquitter.addActionListener(this);
	jtb.add(bquitter);
	
	jtb.addSeparator();

	sse = new saisie_symbole_etat(this); 
	sr = new saisie_regle(); 
	data = new automate(); 
	prop = new propriete_automate(this); 
	fe = new fenetre_essai(this); 
	op = new operations(this);

	tab = new JTabbedPane(); 
	tab.addTab(" Symbols & States ",sse); 
	tab.addTab(" Transitions ",sr); 
	tab.addTab(" Properties ",prop); 
	tab.addTab(" Run ",fe); 
	tab.addTab(" Operations",op);

 
	tab.addChangeListener(new ChangeListener() { 
	    public void stateChanged(ChangeEvent e) { 	 
		if(((JTabbedPane)e.getSource()).getSelectedIndex() == 1) sr.jsp_regle_saisie.updateUI(); 
		if(((JTabbedPane)e.getSource()).getSelectedIndex() == 2){
		    if (data.isRR !=1)
			{
			    int arity = data.isRR;
			    alphnew = data.getA_saisie().alphabetRR(data.getA_saisie(),data.isRR);
			    automate data2 = new automate(alphnew,data.getE_saisie(),data.getT_saisie(),data.getA_saisie());
			    data2.isRR = arity;
			    prop.setPropriete(data2);
			   
			} 
		    else
			prop.setPropriete(data);
		}
	    }});
 
	activation_onglet(); 	
	sr.regle.addActionListener(this);  
	sr.jbv.addActionListener(this);  
	sr.nouveau.addActionListener(this);
        sr.choixS.addActionListener(this);   
        sr.choixE.addActionListener(this);  
	sr.undoR.addActionListener(this);  
	sr.jbva.addActionListener(this);  
	sr.by.addActionListener(this);
	sr.be.addActionListener(this);
	
	fe.run.addActionListener(this); 
	fe.nouveau.addActionListener(this); 
	fe.expression.addActionListener(this); 
	fe.choixS.addActionListener(this); 
	fe.by.addActionListener(this); 

	getContentPane().add(jtb,BorderLayout.NORTH);
	getContentPane().add(tab,BorderLayout.CENTER); 
 
	setVisible(true); 
 
	addWindowListener(new WindowAdapter() { 
		public void windowClosing(WindowEvent e) {} 
	    }); 
	setResizable(true);
	automate tempo = new automate();
	utils.save(tempo,user_dir+"/.tempo.ta");
	
    } 
 
    /** 
     *Activation des onglets 
     */ 
    public void activation_onglet() { 
	sr.regle.setText("");
	sr.choixS.setVisible(true);	
	sr.by.setVisible(true);
	sr.choixE.setVisible(false);
	sr.be.setVisible(false);
	if(data.getA_saisie().isEmpty()) { 
	    tab.setEnabledAt(1,false); 
	    tab.setEnabledAt(2,false); 
	    tab.setEnabledAt(3,false); 
	} 
	else {
	    boolean arite0 = false;
	    int i=0;
	    while(i<data.getA_saisie().size() && !arite0) {
		if(data.getArite(i) == 0) arite0=true;
		else i++;
	    }
	    if(arite0) {
		tab.setEnabledAt(1,true); 
		if(!data.getAutomate_ok()) { 
		    tab.setEnabledAt(2,false); 
		    tab.setEnabledAt(3,false); 
		} 
		else { 
		    tab.setEnabledAt(2,true);
		    if(!data.getT_saisie().left_equals()) tab.setEnabledAt(3,true); 
		}
	    }
	}
    }
 
    /** 
     *fonction qui reinitialise l'automate pour une nouvelle saisie 
     */ 
    public void new_automate() { 
	    sse.vide_liste(); 
	    sr.vide_liste(this); 
	    fe.vide_liste(this); 
	    data = new automate(); 
	    sse.arite.setText("1");
	    alp = new alphabet();
	    activation_onglet(); 
	    tab.setSelectedIndex(0);	   
	    prop.init();
    } 

    public boolean verifie(arbre a, alphabet alpha, ensembleEtats ensetats,boolean racine)
    {
	
	boolean ok = true;
	boolean ok_etat = false;

	symbole symb = new symbole(a.getValeur()+"/1");
	int arit = alpha.app(symb.getSymbole());
	if (racine == false && arit!=-1)
	    {
		JOptionPane.showMessageDialog(this, "This transition is not normalised. It's contains "+a.getValeur()+" in a fonction", "Error Message", 0); 
			    ok = false;
	    } 
	etat etat1= new etat(a.getValeur(),true);
	etat etat2= new etat(a.getValeur(),false);
	if (ensetats.contains(etat1) || ensetats.contains(etat2))
	    {
		arit=0;
		ok_etat = true;
	    }
	if (arit!=-1)
	{
	    if ( arit == a.getSousArbres().size() )
		{
		   
		    if (a.getSousArbres().size()!=0)
			{
			    for ( int i = 0; i<a.getSousArbres().size() && ok;i++)
				{
				  
				    ok = ok && verifie(a.getSousArbres().getArbre(i),alpha,ensetats,false);
				}
			}
		}
	    else
		{
		    if ( ok_etat )
			{
			    JOptionPane.showMessageDialog(this, "arity of "+a.getValeur() +" = 0", "Error Message", 0); 
			    ok = false;
			}
		    else
			{JOptionPane.showMessageDialog(this, "arity of "+a.getValeur() +" = " +arit +", not "+a.getSousArbres().size(), "Error Message", 0); 
			ok = false;
			}
		}
	}   		
	else
	    {
		JOptionPane.showMessageDialog(this, "symbol "+a.getValeur()+" not exists ", "Error Message", 0); 
		ok=false;
	    }

	return ok;
    }
 
    /** 
     *Gestion des evenements 
     *@param evt evenement en cours 
     */ 
    public void actionPerformed(ActionEvent evt) { 
	
	if(evt.getActionCommand().equals("Quit")){
	    if(JOptionPane.showConfirmDialog(this,"Are you sure to quit ?","Confirmation.",JOptionPane.OK_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE) ==JOptionPane.OK_OPTION) System.exit(0); 
	}
 
	if(evt.getActionCommand().equals("New")) new_automate(); 
 

	

	
	if(evt.getActionCommand().equals("Open")) { 
	    new_automate(); 
	    data = utils.ouvrir(this);
	    data.setAutomate_ok(false); 
	    activation_onglet(); 
	} 
 
	if(evt.getActionCommand().equals("Save")) { 
	    if(!data.automate_incomplet() )
		{ 
		    if ( data.isRR != 1 )
			{
			    
			   
			    int arity  = data.isRR;
			    alphnew = data.getA_saisie().alphabetRR(data.getA_saisie(),data.isRR);
			    automate data2 =  new automate( alphnew,data.getE_saisie(),data.getT_saisie(),data.getA_saisie());
			    data2.isRR = arity;
			    utils.enregistrer(data2,this); 
			}
		    else utils.enregistrer(data,this);
		} 
	    else JOptionPane.showMessageDialog(this, " Incomplete automaton!!!", "Warning!!", JOptionPane.WARNING_MESSAGE); 
	    
	}
	
	if(evt.getActionCommand().equals("About"))
	    JOptionPane.showMessageDialog(this,"TAJA - Tree-tuple Automata for Java version 2.0 \nAn application to manipulate Tree-tuple automata.\n\nFabrice Leblois\nArnaud Lauret.     University  of Angers v1.0 (2000) \n \nBenot LECLAND  LIFO Orleans v2.0 (2001)","About...",JOptionPane.INFORMATION_MESSAGE);

	if(evt.getActionCommand().equals("Help")) {
	    JFrame help = new fenetre_help();
	}

	if(evt.getActionCommand().equals("REGLE") || evt.getActionCommand().equals("ajoutez")) {  
	    sr.choixS.setVisible(true);
	    sr.by.setVisible(true);
	    sr.choixE.setVisible(false);
	    sr.be.setVisible(false);
	    
	    String line = new String(sr.regle.getText());
	    // on supprime tous les espaces de la transition tape
	    while ( line.indexOf(" ")!=-1 )
		line = line.substring(0,line.indexOf(" "))+line.substring(line.indexOf(" ")+1,line.length());
	    
	    if (data.isRR==1) // on est dans le cas automate d'arbre
		{
		   
		    if(!sr.regle.getText().equals("")) {  
			try {  
			      
			    String gauche = new String(line.substring(0,line.indexOf("->")));  
			    String droite = new String(line.substring(line.indexOf("->")+2,line.length())); 
			    expression expr1 = new expression(gauche);
			    if (verifie(expr1.getArbre(),data.getA_saisie(),data.getE_saisie(),true))
				{
				    data.addTransition(gauche,new etat(droite,data.isFinal(droite)));  
				//sr.regle_saisie.append(line + "\n");
				    ((DefaultListModel)sr.regle_saisie.getModel()).addElement(line);
				}
			    sr.regle.setText("");  
			}  
			catch(ArrayIndexOutOfBoundsException e) {  
			JOptionPane.showMessageDialog(this, "Non valid transition 1: " +e.getMessage(), "Error Message", 0);  
			sr.regle.setText("");  
			}  
			catch(StringIndexOutOfBoundsException e) {  
			    JOptionPane.showMessageDialog(this, "Non valid transition 2: " +e.getMessage(), "Error Message", 0);  
			sr.regle.setText("");  
		    }  
		}  
		else JOptionPane.showMessageDialog(this, "Error", "Error Message", 0);  
		data.setAutomate_ok(false);  
		activation_onglet();
	    }
	    else // on est dans le cas RR
		{
		    String ok = "";
		    String etatres = "";
		    String fonct ="";
		    boolean exist = false;
		   	   
		    
		   
		    alphabet essai = new alphabet();
		    
		     
		    if ( line.indexOf("(")== -1 )
			{
			   
			    fonct = new String(line.substring(0,line.indexOf("->")));
			    if ( alphnew.app(fonct) == -1 )
				ok = "The symbol "+ fonct +" is not a correct symbol";
			    else if ( alphnew.app(fonct) != 0 )
				ok = "The arity of the symbol is "+ alphnew.app(fonct);
			    etatres = line.substring(line.indexOf("->")+2,line.length());
			    
			    if ( !data.getE_saisie().contains2(etatres) )
				ok = "This state does not exist";
			    
			    
			}
		    else {
			
		
			fonct = new String(line.substring(0,line.indexOf("(")));
			if ( line.indexOf(")") !=-1) 
			    {
			
					String liste_etat = new String(line.substring(line.indexOf("(")+1,line.indexOf(")")));
					String etatc = "";
					int n = 0;
					while ( liste_etat.indexOf(",")!=-1 ){
					    etatc = liste_etat.substring(0,liste_etat.indexOf(","));
					    liste_etat = new String(liste_etat.substring(liste_etat.indexOf(",")+1,liste_etat.length()));
					  
					    if ( !data.getE_saisie().contains2(etatc) )
						ok = "This state does not exist";
					    n++;
					   
					}
					if ( !data.getE_saisie().contains2(liste_etat) )
					    ok = "This state does not exist";
					n++;
				
					if ( n != alphnew.app(fonct) )
					    ok = "Arity of symbol = "+ alphnew.app(fonct)+" but there is " + n + " states";
					if ( line.indexOf("->") !=-1)
					    {
						fonct = line.substring(0,line.indexOf("->"));
						etatres = line.substring(line.indexOf("->")+2,line.length());
					
						if ( !data.getE_saisie().contains2(etatres) )
						    ok = "This state does not exist";
					    }
					
				
					else
					    {
						ok = " -> is missing" ;
					    }
				    
			    }
			else ok = "A closed parenthesis is missing";
			
		    }
		    if ( ok.equals(""))
			{
			    data.addTransition(fonct,new etat(etatres,data.isFinal(etatres))); 
			    data.setAutomate_ok(false);
			    int arity =data.isRR;
			   
			    ((DefaultListModel)sr.regle_saisie.getModel()).addElement(fonct+"->"+etatres);
			    activation_onglet();
			    sr.regle.setText("");
			}
		    else
			{
			    JOptionPane.showMessageDialog(this, ok, "Error Message", 0);
			}
		}
	}
	
	
	
	if(evt.getActionCommand().equals("UndoRegle")) {  
	    if(!data.getT_saisie().isEmpty()) {
		gui.utils.delItems(sr.regle_saisie,data.getT_saisie());
		data.setAutomate_ok(false); 
		activation_onglet();
	    }  
	}  
	if(evt.getActionCommand().equals("REGLE") || evt.getActionCommand().equals("OK1") || evt.getActionCommand().equals("OK2")  || evt.getActionCommand().equals("ajoutez"))
	   
	    alphnew = data.getA_saisie().alphabetRR(data.getA_saisie(),data.isRR);
	  
	if(evt.getActionCommand().equals("CHOIXS")) {  
	   
	    selS = new String(sr.choixS.getSelectedItem().toString()); 
	   
	   
	    
	}

	if(evt.getActionCommand().equals("CHOIXE")) {  
	   selE = new String(sr.choixE.getSelectedItem().toString());
	  
	}
	if(evt.getActionCommand().equals("OK1")) {  
	    if(sr.regle.getText().equals("")) {  
		try {  
		 		    String choix = selS;  
		    String sym;  
		    if(choix.endsWith(")")) sym = new String(choix.substring(0, choix.indexOf("(")));  
		    else sym = new String(choix);  
		    int arite = 0;
		    if (data.isRR == 1) 
		
			arite = data.getArite(data.getA_saisie().getSymboleIndex(sym));  
		
		    else 
			
			arite =  alphnew.app(sym);
		    
		    if(arite != 0) sym += "(";  
		    else sym += "->";  
		    sr.regle.setText(sym); 
		    sr.choixS.setVisible(false);
		    sr.by.setVisible(false); 
		    sr.choixE.setVisible(true);
		    sr.be.setVisible(true);
			} 	
		catch(Exception e) {  
		    JOptionPane.showMessageDialog(this, " Non valid transition :(CHOIXS) " +e.getMessage(), "Error Message", 0);  
                    sr.regle.setText("");  
		}  
	    }  
	}  
	
	if(evt.getActionCommand().equals("OK2")) {  
	    if(!sr.regle.getText().equals("")) {  

		try { 
		   
		    String ch = selE;
		    String fonct = new String(sr.regle.getText());  
		    String sym = new String();  
		    int arite=0;  
		    if(fonct.indexOf('(') != -1) {  
			sym = fonct.substring(0,fonct.indexOf("("));  
			if (data.isRR == 1) arite = data.getArite(data.getA_saisie().getSymboleIndex(sym)); 
			else arite =  alphnew.app(sym);
			    
		    }  
		    if(fonct.endsWith("(")) {  
			if(arite == 1) sr.regle.setText(fonct + ch+")->");  
			else sr.regle.setText(fonct + ch+",");  
		    }  
		    else if(fonct.endsWith(",")) {  
			int nb_virgule=0;  
			for(int i=0;i<fonct.length();i++) {  
			    if(fonct.charAt(i) == ',') nb_virgule++;  
			}  
			if(nb_virgule < (arite-1)) sr.regle.setText(fonct + ch+",");  
			else 
			    if(nb_virgule == (arite-1)) 
				sr.regle.setText(fonct + ch+")->");    
		    }  
		    else 
			if(fonct.endsWith("->")) 
			    
			    sr.regle.setText(fonct + ch);  
		}  
		catch(Exception e) {  
		    JOptionPane.showMessageDialog(this, "Non valid Transition:(CHOIXE) " +e.getMessage(), "Error Message", 0); 
		    sr.regle.setText("");  
		}  
	    }  
	}  

	if(evt.getActionCommand().equals("OK")) {  
	    if(!data.getT_saisie().isEmpty()) 
		{
		    
		    
		    data.setAutomate_ok(true);
		    if ( data.isRR != 1 )
			{
			    
			   
			    int arity  = data.isRR;
			    alphnew = data.getA_saisie().alphabetRR(data.getA_saisie(),data.isRR);
			    automate data2 =  new automate( alphnew,data.getE_saisie(),data.getT_saisie(),data.getA_saisie());
			    data2.isRR = arity;
			    utils.save(data2,user_dir+"/.tempo.ta"); 
			}
		   else 
		       utils.save(data,user_dir+"/.tempo.ta"); 

	   
		}  
	    else JOptionPane.showMessageDialog(this, " There is no transitions !", "Warning!!", JOptionPane.WARNING_MESSAGE);  
	    activation_onglet();  
	}  
	
	
	if(evt.getActionCommand().equals("NEW")) { 
	    if(((JButton)evt.getSource()).equals(sr.nouveau)) {	
		sr.choixS.setVisible(true);	
		sr.by.setVisible(true);
		sr.choixE.setVisible(false);
		sr.be.setVisible(false);
		sr.regle.setText("");
	    }
	    if(((JButton)evt.getSource()).equals(fe.nouveau)) {
		fe.choixS.setVisible(true);
		fe.by.setVisible(true);
		fe.expression.setText("");
		fe.vide_run();
		compteur =0;
	
	    }
	    
	}
 
	if(evt.getActionCommand().equals("RUN")) { 
	  
	    compteur=0;
	    fe.choixS.setVisible(true);
	    fe.by.setVisible(true);
	    if(!fe.expression.getText().equals("") ) {
		String line = this.fe.expression.getText();
		while ( line.indexOf(" ")!=-1 )
		    line = line.substring(0,line.indexOf(" "))+line.substring(line.indexOf(" ")+1,line.length());
		this.fe.expression.setText(line);
		expression e = new expression(line);
		run therun;
		if (data.isRR !=1)
		    {
			int arity  = data.isRR;
		
		
			alphnew = data.getA_saisie().alphabetRR(data.getA_saisie(),data.isRR);
			automate data2 = new automate(alphnew,data.getE_saisie(),data.getT_saisie(),data.getA_saisie());
			data2.isRR = arity;
			prop.setPropriete(data2);
			// on reassemble l'expression en expression reconnue par la RR
			expression[] exp  = new expression[data2.isRR];
			String reste = line;
		
				for (int i=0;i<data2.isRR-1;i++)
			  {
				if ( reste.indexOf("|")!=-1)
			  {
				
			exp[i] = new expression(reste.substring(0,reste.indexOf("|")));
				
			reste = reste.substring(reste.indexOf("|")+1,reste.length());
				
				    }
			}
				exp[data2.isRR-1] = new expression(reste);
		
		
			Vector v = new Vector();
			for (int i=0;i<data2.isRR;i++)
			    {
				v.addElement(exp[i].getArbre());
			    }
	
		
		
		
			
			
			
			therun = new run(data2,new expression(utils.decoupe(v,data2)));
			fe.first.setEnabled(true);
			fe.prec.setEnabled(true);
			fe.suiv.setEnabled(true);
			fe.last.setEnabled(true);
			fe.zoom_run.setEnabled(true);
			fe.updateRun(therun);
		    }
	    else
		therun = new run(this.data,e); 
		fe.first.setEnabled(true);
		fe.prec.setEnabled(true);
		fe.suiv.setEnabled(true);
		fe.last.setEnabled(true);
		fe.zoom_run.setEnabled(true);
		fe.updateRun(therun); 
	       
		}
	} 
 	if(evt.getActionCommand().equals("CHOIXS2")) {  
	   
	    selS2 = new String(fe.choixS.getSelectedItem().toString());
	    
	}

	if(evt.getActionCommand().equals("OK3")) { 
	    try {
	
		String choix = selS2;
		String term = new String(fe.expression.getText()); 
		String terme;
		String debut = term.substring(0,term.trim().lastIndexOf("|")+1);
		if ( term.trim().lastIndexOf("|")!=-1)
		     terme = term.substring(term.lastIndexOf("|")+1,term.length()).trim();
		else  terme = term;
	
		if(terme.equals("") || terme.endsWith("(") || terme.endsWith(",")) {
		
		    if(choix.endsWith(")")) terme += choix.substring(0,choix.indexOf('(')+1);
		    else terme += choix;
		}
		if(terme.indexOf(',') != -1) {
		    if(terme.endsWith("(") || terme.endsWith(",")) fe.expression.setText(terme);
		    else fe.expression.setText(fe.parenthesage(terme,data));
		}
		else {
		    if(terme.endsWith("(")) fe.expression.setText(terme);
		    else fe.expression.setText(fe.parenthesage(terme,data));
		}
	
		String ch = fe.expression.getText();
		fe.expression.setText(debut+ch);	
	
		if (  !fe.expression.getText().trim().equals("") && !fe.expression.getText().endsWith("(") && !fe.expression.getText().endsWith(",")) 
		{
		    compteur++;
		}
			if (compteur==data.isRR)
		{
		    fe.choixS.setVisible(false);
		    fe.by.setVisible(false);
		}
		else if (  !fe.expression.getText().trim().equals("") && !fe.expression.getText().endsWith("(") && !fe.expression.getText().endsWith(",")) 
		    {
			String ch1 = fe.expression.getText()+" | ";
			fe.expression.setText(ch1);
		    }
		
		
	    }
	    catch(Exception e) { 
		JOptionPane.showMessageDialog(this, "Non valid term: " +e.getMessage(), "Error Message", 0); 
		fe.expression.setText(""); 
	    } 
	} 

    }//fin actionPerformed 
} 
 
