/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import data.*;
import java.util.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 

/** 
 *Fenetre de propriete 
 */ 
public class propriete_automate extends JPanel implements ActionListener{ 
    JTextArea prop_auto; 
    JTextArea prop_auto_modif;
    JCheckBox complet;
    JCheckBox reduit;
    JCheckBox deterministe;
    JButton modif;
    JButton save;
    JButton replace;
    fenetre_saisie parent;
    JLabel depart;
    automate a_modif;
    automate a;    
    automate retour;
    boolean det_called;
    public propriete_automate(fenetre_saisie parent) {  
	this.parent = parent;
	det_called = false;
	//Label Automate de dpart:
	JLabel ldepart = new JLabel("Initial automaton :");       
	Box box_depart = new Box(BoxLayout.X_AXIS);
	depart = new JLabel();
	box_depart.add(ldepart);
	box_depart.add(Box.createHorizontalStrut(5));
	box_depart.add(depart);
	box_depart.add(Box.createHorizontalGlue());
	//Zone de texte automate de dpart.
	prop_auto = new JTextArea(); 
	prop_auto.setEditable(false); 
	prop_auto.setLineWrap(true); 
	prop_auto.setBackground(Color.lightGray); 
	prop_auto.setMargin(new Insets(5,5,5,5));
	prop_auto.setToolTipText("Initial automaton");
	JScrollPane jsp_prop_auto = new JScrollPane(); 
	jsp_prop_auto.getViewport().add(prop_auto);
	//Label Automate modifi.
	JLabel modifie = new JLabel( "Modified automaton:");
	Box box_modifie = new Box(BoxLayout.X_AXIS);
	box_modifie.add(modifie);
	
	//Cases  cocher.
	Box controles = new Box(BoxLayout.X_AXIS);
	complet = new JCheckBox("Complete");
	reduit = new JCheckBox("Reduced");
	deterministe = new JCheckBox("Determinist");
	
	complet.addActionListener(this); 
	reduit.addActionListener(this);
	deterministe.addActionListener(this);

	controles.add(complet);
	controles.add(Box.createHorizontalStrut(5));
	controles.add(reduit);
	controles.add(Box.createHorizontalStrut(5));
	controles.add(deterministe);
	box_modifie.add(Box.createHorizontalStrut(15));
	box_modifie.add(controles);
	box_modifie.add(Box.createVerticalStrut(20));
	box_modifie.add(Box.createHorizontalGlue());
	//Zone de texte automate modifi.
	prop_auto_modif = new JTextArea(); 
	prop_auto_modif.setEditable(false); 
	prop_auto_modif.setLineWrap(true); 
	prop_auto_modif.setBackground(Color.lightGray); 
	prop_auto_modif.setMargin(new Insets(5,5,5,5));
	prop_auto_modif.setToolTipText("Modified automaton");
	JScrollPane jsp_prop_auto_modif = new JScrollPane(); 
	jsp_prop_auto_modif.getViewport().add(prop_auto_modif);	
	//Boutons modifier, enregistrer, remplacer
	Box modifsave = new Box(BoxLayout.X_AXIS);
	modif = new JButton("Modify", new ImageIcon("images/exec.gif"));
	modif.addActionListener(this);
	modif.setActionCommand("modif");
	modif.setToolTipText("Modify initial automaton");
	save = new JButton("Save",new ImageIcon("images/save.gif"));
	save.addActionListener(this);
	save.setActionCommand("save");
	save.setToolTipText("Save modified automaton");
	replace = new JButton("Replace",new ImageIcon("images/modify.gif"));
	replace.addActionListener(this);
	replace.setActionCommand("Remplace");
	replace.setToolTipText("Replace initial automaton");
	modifsave.add(modif);
	modifsave.add(Box.createHorizontalStrut(5));	
	modifsave.add(save);	
	modifsave.add(Box.createHorizontalStrut(5));
	modifsave.add(replace);
	//Ajout des != lments:
	Box panel = new Box(BoxLayout.Y_AXIS);
	panel.add(Box.createVerticalStrut(5));
	panel.add(box_depart);
	panel.add(Box.createVerticalStrut(5));
	panel.add(jsp_prop_auto);
	panel.add(Box.createVerticalStrut(5));
	panel.add(box_modifie);
	panel.add(Box.createVerticalStrut(5));
	panel.add(jsp_prop_auto_modif);
	panel.add(Box.createVerticalStrut(5));
	panel.add(modifsave);
	setLayout(new BorderLayout());
	add(panel,BorderLayout.CENTER);
    } 
 
    public void init(){
	complet.setSelected(false);
	complet.setEnabled(true);
	reduit.setSelected(false);
	reduit.setEnabled(true);
	deterministe.setSelected(false);
	deterministe.setEnabled(true);
	prop_auto.setText("");
	prop_auto_modif.setText("");
    }
    
    public void setPropriete(automate a) { 	
	prop_auto.setText("");
	prop_auto_modif.setText("");
	save.setEnabled(false);
	modif.setEnabled(true);
	replace.setEnabled(false);
	complet.setSelected(false);
	complet.setEnabled(true);
	reduit.setSelected(false);
	reduit.setEnabled(true);
	deterministe.setSelected(false);
	deterministe.setEnabled(true);
	
	this.a=a;
	try { 
	    prop_auto.setText(a.print());
	    prop_auto.setCaretPosition(0);
	  
	    completude c = new completude(a);
	    String etat = new String();
	    if(c.isComplet()){
		complet.setSelected(true);
		complet.setEnabled(false);
		etat += " complete ,";      
	    }

	    reduction r = new reduction(this.a.copy());
	    if(r.isReduit()){
		reduit.setSelected(true);
		reduit.setEnabled(false);		
		etat+=" reduced ,";
	    }
	    if(!a.getT_saisie().left_equals()){

		deterministe.setSelected(true);
		deterministe.setEnabled(false);
		etat +=" determinist ";
	    }
	    
	    if(!a.getT_saisie().left_equals() && c.isComplet() && r.isReduit()){
		modif.setEnabled(false);
		save.setEnabled(false);
		replace.setEnabled(false);
	    } 
	    try{
		if(etat.charAt(etat.length()-1)==','){
		    etat = etat.substring(0,etat.length()-1);
		}
	    }catch(Exception e){}
	    depart.setText(etat);
	    validate();
	} 
	catch(Exception e) { 
	    System.out.println("erreur propriete automate: "+e.getMessage()); 
	} 
    } 
 
    public void actionPerformed(ActionEvent e){
	
	if(e.getActionCommand().equals("modif")){
	    String modif = new String();;
	    if((complet.isSelected() && complet.isEnabled()) || (reduit.isSelected() && reduit.isEnabled()) || (deterministe.isSelected() && deterministe.isEnabled())) {
		automate temp = a;
		if(complet.isEnabled() && complet.isSelected()){
		    completude c = new completude(temp);
		    temp = c.auto_complet();
		}
		if(reduit.isEnabled() && reduit.isSelected()){
		    reduction r = new reduction(temp);
		    temp = r.auto_reduit();
		}
		if(deterministe.isEnabled() && deterministe.isSelected()){
		   
		    det_called = true;
		   
		    retour = utils.renomme_tous(a,parent);

		   
		    algo_DET det = new algo_DET(retour);
		    
		    temp = det.auto_DET();
		    
		    reduit.setEnabled(false);
		    reduit.setSelected(true);
		    
		    
		}
		a_modif = temp;
		prop_auto.setText("");
		prop_auto_modif.setText("");		
		save.setEnabled(true);
		replace.setEnabled(true);
		validate();
		prop_auto.setText(a.print());
		prop_auto.setCaretPosition(0);
		prop_auto_modif.setText(modif + a_modif.print());
		prop_auto_modif.setCaretPosition(0);
		validate();
	    }
	}
	else {
	    if(e.getActionCommand().equals("save")) {	
		if ( a.isRR == 1)
		    utils.enregistrer(a_modif,parent);
		else
		    {
			a_modif = new automate ( a_modif.getA_saisie(),	a_modif.getE_saisie(),a_modif.getT_saisie(),a.getARR_saisie());	
			a_modif.isRR = a.isRR;
			utils.enregistrer(a_modif,parent);

		    }
	    }
	    else {		
		if(e.getActionCommand().equals("Complete")) {
		    if(reduit.isEnabled()) 
			reduit.setSelected(false);
		    if(deterministe.isEnabled()) 
			deterministe.setSelected(false);
		}
		else {
		    if(e.getActionCommand().equals("Reduced")) {
			if(complet.isEnabled()) 
			    complet.setSelected(false);
			if(deterministe.isEnabled()) 
			    deterministe.setSelected(false);
		    }
		    else {
			if(e.getActionCommand().equals("Determinist")) {
			    if(reduit.isEnabled()) 
				reduit.setSelected(false);
			    if(complet.isEnabled()) 
				complet.setSelected(false);
			}else{
			    if(e.getActionCommand().equals("Remplace")){
				if(JOptionPane.showConfirmDialog(parent,"Do you want this automaton to be the current automaton ?","Use of the new automaton",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION) { 
				    
				   
				    parent.new_automate(); 
				    if ( a.isRR !=1 ) 
					a_modif = new automate ( a.getARR_saisie(),	a_modif.getE_saisie(),a_modif.getT_saisie(),a.getA_saisie());	
				    a_modif.isRR = a.isRR;
				    parent.sse.arite.setText((new Integer(a.isRR)).toString());
				  
				    gui.utils.save(a_modif,parent.user_dir+"/.auto.ta.temp");
				    automate data = new automate(new File(parent.user_dir+"/.auto.ta.temp"));
				    
				    
				   
				    parent.data = data;	
				    utils.listes(parent.data,parent);
				     
				    parent.data.setAutomate_ok(true); 
				    parent.activation_onglet();
				    parent.tab.setSelectedIndex(2);
				    if(det_called){
					det_called = false;
					reduit.setEnabled(false);
					reduit.setSelected(true);					
				    }
				    String etat = new String();
				    if(!complet.isEnabled() && complet.isSelected())
					etat += " complete ,";
				    if(!reduit.isEnabled() && reduit.isSelected())
					etat+=" reduced ,";
				    if(!deterministe.isEnabled() && deterministe.isSelected())
					etat +=" determinist";
				    if(etat.charAt(etat.length()-1)==','){
					etat = etat.substring(0,etat.length()-1);
				    }
				    depart.setText(etat);				    
				    if(reduit.isSelected() && deterministe.isSelected() && complet.isSelected()){
					save.setEnabled(false);
					modif.setEnabled(false);
					replace.setEnabled(false);
				    }
				}
			    }
			}
		    }
		}		
	    }
	}
    }

}
    
