/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import javax.swing.tree.*;
import java.io.*;

public class treeNode extends DefaultMutableTreeNode{

    String filename;
    
    public treeNode(String label, String filename){
	super(label);
	this.filename = filename;
    }

    public String getFileName(){
	return filename;
    }

    public boolean addDir(String dirName, boolean rec){
	if(isEmpty()){
	    try{
		remove(0);}
	    catch(ArrayIndexOutOfBoundsException e){}
	}
	File dir = new File(dirName);
	boolean leaf_added = false;       
	if(dir.exists() && dir.isDirectory()){
	    treeNode new_node = new treeNode(dir.getName(),dir.getAbsolutePath());
	    String[] content = dir.list();	    
	    boolean[] files = new boolean[content.length];
	    for(int i=0;i<content.length;i++){
		File temp = new File(dir,content[i]);
		if(!temp.isDirectory() && temp.getName().endsWith(".ta")){					    
		    leaf_added = true;
		    files[i]=true;
		}else{
		    files[i]=false;
		    //recursion
		    if(temp.isDirectory() && rec){			
			leaf_added = new_node.addDir(temp.getAbsolutePath(),rec);
		    }
		}
	    }
	    //ajout des fichiers aprs les rpertoires.
	    for(int i=0;i<files.length;i++){
		if(files[i]){
		    //nouvelle feuille
		    File temp = new File(dir,content[i]);
		    new_node.add(new treeNode(temp.getName(),temp.getAbsolutePath()));
		}
	    }
	    if(leaf_added)
		add(new_node);
	}
	return leaf_added;
    }

    public boolean addFile(String fileName){
	if(isEmpty()){
	    try{
		remove(0);}
	    catch(ArrayIndexOutOfBoundsException e){}
	}
	File file = new File(fileName);
	boolean leaf_added=false;	
	if(!file.isDirectory() && file.getName().endsWith(".ta")){
	    
	    if (fileName.equals(".tempo.ta"))
		add(new treeNode("current ta",file.getAbsolutePath()));
	    else
		add(new treeNode(file.getName(),file.getAbsolutePath()));
	    leaf_added = true;
	}
	return leaf_added;
    }

    public void createDir(String dirName){
	if(isEmpty()){
	    try{
		remove(0);}
	    catch(ArrayIndexOutOfBoundsException e){}
	}	
	treeNode theDir = new treeNode(dirName,"no dir");
	theDir.add(new treeNode("Empty","no dir"));
	add(theDir);
    }

    public boolean isEmpty(){
	if(!isLeaf())
	    return (getFirstChild().toString().equals("Empty") && ((treeNode)getFirstChild()).getFileName().equals("no dir"));
	else
	    return true;
    }    
}
