/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.*;
import data.*;

public class treeView extends JPanel implements TreeSelectionListener{

    operations parent;
   
    JTree tree;
    treeNode root;
    treeNode session;
    treeNode selected;
   
    public treeView(gui.operations parent){
	super();
	this.parent = parent;
	treeNode root = new treeNode("Automata","no dir");
	session = new treeNode("Session","no dir");
	session.add(new treeNode("Empty","no dir"));
	session.addFile(parent.parent.user_dir+"/.tempo.ta");
	root.add(session);

	tree = new JTree(root);
	tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
	tree.addTreeSelectionListener(this);
	setLayout(new BorderLayout());
	JScrollPane jsp_tree = new JScrollPane(tree);
	add(jsp_tree, BorderLayout.CENTER);
	selected=root;
    }
    
   

    public void setNewRoot(treeNode new_root){	       
	tree = new JTree(root);
	//tree.clearSelection();
	tree.updateUI();
    }


    public void valueChanged(TreeSelectionEvent evt){
	selected = (treeNode)(evt.getPath().getLastPathComponent());
    }

    public void addAutomate(String fichier){
	try{
	    if(selected!=null){
		if(!selected.isLeaf())
		    
		    selected.addFile(fichier);
		else 
		    ((treeNode)selected.getParent()).addFile(fichier);
	    }
	}
	catch(NullPointerException e){
	  
		root.addFile(fichier);
	}
	tree.clearSelection();
	tree.updateUI();              	
    }

    public void addToSession(String fichier){
	session.addFile(fichier);
	tree.updateUI();
    }

    public void addDirAutomate(String dir, boolean rec){
	try{
	    if(selected!=null){
		if(!selected.isLeaf())
		    selected.addDir(dir,rec);
		else
		    ((treeNode)selected.getParent()).addDir(dir,rec);
	    }
	}
	catch(NullPointerException e){
		root.addDir(dir,rec);
	}
	tree.clearSelection();
	tree.updateUI();
    }

    public void createDir(String dir){
	try{
	    if(selected!=null){
		if(!selected.isLeaf())
		    selected.createDir(dir);
		else
		    ((treeNode)selected.getParent()).createDir(dir);
	    }
	}
	catch(NullPointerException e){
	    root.createDir(dir);
	}
	tree.clearSelection();
	tree.updateUI();
    }

    public void delSelection(){
	try{
	    if(! ( (selected.toString().equals("Session") || selected.toString().equals("Automata")|| selected.toString().equals("Empty") ) && selected.getFileName().equals("no dir") )){
		treeNode elder = (treeNode)selected.getParent();
		((MutableTreeNode)selected.getParent()).remove((MutableTreeNode)selected);
		if(elder.getChildCount()==0){
		    elder.add(new treeNode("Empty","no dir"));
		}
	    }
	}catch(NullPointerException e){}
	tree.clearSelection();
	selected=root;
	tree.updateUI();
    }

    public String[] getSelected(){
	String[] retour = new String[2];
	retour[0]="";
	retour[1]="";
	try{
	    if(selected.isLeaf() && !selected.toString().equals("Empty")){
		retour[0] = selected.toString();
		retour[1] = selected.getFileName();
	    }
	}catch(NullPointerException e){}
	return retour;
    }

    public void zoom(){
	String titre;
	String texte;
	try{
	    if(selected.isLeaf() && !selected.toString().equals("Empty")){
		titre = selected.toString();
		
		texte = new automate(new File(selected.getFileName())).print();
		zoomOperation zo = new zoomOperation(titre, texte);
	    }
	}catch(NullPointerException e){}
    }
}
